try:
    import dbus
except:
    pass
import sys
import time
import os
import gettext
import locale

locale.setlocale(locale.LC_ALL, '')
gettext.install('alunn')

def log_entry(message, time_stamp = True, warning = False):
    time_string = "[" + time.strftime('%Y-%m-%y %H:%M') + "] "
    if not time_stamp:
        time_string = " " * (len(time_string) - 6) + "....  "
    warn_string = warning and "[" + _("WARNING") + "] " or ""
    stream = warning and sys.stderr or sys.stdout 
    stream.write(time_string + warn_string + message + "\n")

def check_service(service_name, bus):
    try:
        bus_obj = bus.get_object('org.freedesktop.DBus', '/org/freedesktop/DBus')
        bus_iface = dbus.Interface(bus_obj, 'org.freedesktop.DBus')
        bus_services = bus_iface.ListNames()
        return service_name in bus_services 
    except:
        return False
