# -*- coding: utf-8 -*-
#
# This entire file is just an fast and ugly workaround for this bug:
#
#     http://bugs.kde.org/show_bug.cgi?id=138295
#
# Hopefully this will be fixed in the future, and I can remove this file again.
# If anyone can shed some light on this issue (i.e it's not really a bug in KDE,
# but me doing something wrong) please let me know!! 
#

import gtk
import gobject
try:
    import dbus
except:
    pass
import os
import sys
import time
import subprocess
from alunn.log import *
import gettext
import locale

locale.setlocale(locale.LC_ALL, '')
gettext.install('alunn')

class NotifyIconBuggyTray:
    status = {'updates':False, 'news':False}
    tooltip = {
        'updates': _("Updates available!"),
        'news':    _("Unread news!"),
        'both':   _("Updates available and unread news!")
        }
    urls = []

    pacman_icon_file = "/usr/share/pixmaps/alunn-pacman.png"
    arch_icon_file = "/usr/share/pixmaps/alunn-arch.png"
    news_id_file = os.path.expanduser('~/.alunn.news')
    updatecommand = None
    webreader = None
    news = None
    updates_last_time = []
    updating_done = False
    news_last_time = []
    tray_process = None

    try:
        system_bus = dbus.SystemBus()
    except (NameError, dbus.exceptions.DBusException):
        pass
    try:
        session_bus = dbus.SessionBus()
    except (NameError, dbus.exceptions.DBusException):
        pass

    # Check if system support notifications
    try:
        if check_service('org.freedesktop.Notifications', session_bus) or dbus.Interface(session_bus.get_object('org.freedesktop.DBus', '/org/freedesktop/DBus'), 'org.freedesktop.DBus').StartServiceByName('org.freedesktop.Notifications', dbus.UInt32(0)) == 1:
            notification = dbus.Interface(session_bus.get_object('org.freedesktop.Notifications', '/org/freedesktop/Notifications'), 'org.freedesktop.Notifications')
            notificationid = 0
        else:
            notification = None
    except NameError:
        notification = None
    except dbus.exceptions.DBusException:
        notification = None
    if not notification:
        log_entry(_("System is not able to show notifications"), True, True)
        
    def show_notify_icon(self, title, message, type, urls=None):
        if message != self.news_last_time and message != self.updates_last_time:
            log_entry(type.capitalize() + ": " + message.replace("\n", "; "), False)
            if type == _("updates"):
                self.updates_last_time = message
                self.status['updates'] = True
                icon = self.pacman_icon_file
            else:
                self.news_last_time = message
                self.urls = urls
                self.status['news'] = True
                icon = self.arch_icon_file
            # Workaround for bug(?) in libnotify
            message_old = message
            message = ''
            for char in message_old:
                if char == '&':
                    message += 'and'
                else:
                    message += char
            return (type, icon, title, message)
        else:
            return False

    def toggle_icon(self):
        if self.status['updates'] == False and self.status['news'] == False:
            if self.tray_process:
                os.kill(self.tray_process.pid, 1)
            

    def show_notify_balloon(self, args):
        if args:
            if self.tray_process:
                os.kill(self.tray_process.pid, 1)
                # check if there have been performed an upgrade
                self.updating_done = subprocess.Popen(["grep", "u_p_d_a_t_i_n_g"], stdin=self.tray_process.stdout, stdout=subprocess.PIPE).communicate()[0]
            if args[0] == _("updates"):
                self.updating_done = False
                news = self.news_last_time
                updates = args[3]
                notify_type = '--notify-updates'
            else:
                news = args[3]
                if self.updating_done:
                    updates = ''
                else:
                    updates = " ".join(self.updates_last_time)
                notify_type = '--notify-news'
            try:
                news_fp = open(self.news_id_file)
                try:
                    old_news_id = news_fp.read().split("\n")[0]
                finally:
                    news_fp.close()
            except IOError:
                old_news_id = ''
            if news == [] or old_news_id == self.urls[0]:
                news = ''
            if self.notification:
                can_notify = '--can-notify=true'
            else:
                can_notify = '--can-notify=false'

            self.tray_process = subprocess.Popen(['alunn_notify_buggy_tray_hack',
                                                  can_notify,
                                                  notify_type,
                                                  '--news=' + news,
                                                  '--updates=' + updates,
                                                  '--updatecommand=' + self.updatecommand,
                                                  '--webreader=' + self.webreader,
                                                  '--urls=' + " ".join(self.urls)],
                                                 stdout=subprocess.PIPE)

    def __init__(self, updatecommand, webreader, news):
        self.updatecommand = updatecommand
        self.webreader = webreader
        self.news = news
